#include <stdio.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <assert.h>
#include <netinet/in.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>

unsigned char buffer[10];
unsigned char factorial_result[2048/8 + 2];

void handle(int dsock, int octets_read) {
	int result;

	if (octets_read == sizeof(buffer)) {
		int iter, n;

		memcpy(&iter, buffer +2, 4);
		memcpy(&n, buffer +6, 4);
		iter = ntohl(iter);
		n = ntohl(n);

		fprintf(stderr, "iter=%d n=%d\n", iter, n);

		result = write(dsock, &factorial_result, 
			sizeof(factorial_result));
		factorial_result[0] = (sizeof(factorial_result) - 2) >> 8;
		factorial_result[1] = (sizeof(factorial_result) - 2) & 0xff;
		assert(result == sizeof(factorial_result));
		
	} else {
		result = read(dsock + octets_read, buffer, 
				sizeof(buffer)-octets_read);
		assert(result > 0);
		handle(dsock, result + octets_read);
	}
}

int main() {
	int result;
	struct sockaddr_in addr;
	int lsock;
	int optval = 1;

	lsock = socket(PF_INET, SOCK_STREAM, 0);
	assert(lsock >= 0);

	result = setsockopt(lsock, SOL_SOCKET, SO_REUSEADDR, &optval, 
				sizeof optval);
	assert(result == 0);

	addr.sin_family = PF_INET;
	addr.sin_port = htons(5000);
	addr.sin_addr.s_addr = INADDR_ANY;
	result = bind(lsock, (struct sockaddr*)&addr, sizeof(addr));
	assert(result == 0);

	result = listen(lsock, 1000);
	assert(result == 0);

	while (1) {
		int dsock;
		dsock = accept(lsock, (struct sockaddr*)&addr, &result);
		assert(dsock >= 0);
		handle(dsock, 0);

		close(dsock);
	}

	return 0;
	
}
